;****************************************************************************************
;*						DCC Informationen einlesen										*
;****************************************************************************************
;liest die DCC Informationen ein
;Rckgabe erfolgt in "byteA bis byteF"
;(Register byteA bis ByteF, Bitzaehler und Flag werden bentigt Sreg wird verndert) 
.cseg

DCC_schleife:
 		clr  	Bitzaehler     		; loesche den BitCounter wieder
        clr  	byteA				; loesche die Empfangsregister wieder
        clr 	byteB
        clr  	byteC
        clr  	byteD
        clr  	byteE
        clr  	byteF
		cbr  	Flag,(1<<neuesbit)+(1<<bit)+(1<<keinDCC)
  	
PREAMBLE: 							; Prfe Prambel nach NMRA-DCC
	  	sbrs 	Flag,neuesbit		; wenn kein neues Bit dann
	  	rjmp 	PC-1				; Schleife
	  	cbr 	Flag,(1<<neuesbit)	; lsche flag fr neues Bit
	  	sbrs 	Flag,bit			; wenn das neue Bit = 1 dann erhhe Zhler
	  	rjmp 	PreEND				; ansonsten Signal fr Prambel Ende
	  	inc 	Bitzaehler			;
	  	rjmp 	PREAMBLE			; Schleife
PreEND: 
		cpi 	Bitzaehler,10		; wenn Bitzhler kleiner 10
	  	brlo 	PreFehl				; dann Fehler		  
	  	clr 	Bitzaehler			; lsche Zhler
	  	rjmp 	lesebyteA  			; hole Adresse (kurze NMRA-Adresse )
 
PreFehl:rjmp 	DCC_schleife		; Endlosschleife

lesebyteA: 							; hole erstes von bis zu sechs Bytes
	  	sbrs 	Flag,neuesbit		; wenn kein neues Bit dann
	  	rjmp 	PC-1				; Schleife
	  	cbr 	Flag,(1<<neuesbit)	; lsche flag fr neues Bit
	  	cpi 	Bitzaehler,8		; vergleiche mit Bytelnge		;
	  	breq 	byteAENDE			; und springe wenn Byte eingelesen
	  	sec							; setzte Carry
	  	sbrs 	Flag,bit			; wenn empfangenes Bit=1 1x springen
	  	clc							; lsche Carry
	  	rol 	byteA				; schiebe Carry von rechts in das Register
	  	inc 	Bitzaehler			; erhhe Zhler
	  	rjmp 	lesebyteA		  	; Schleife
byteAENDE:
		mov 	w,byteA				; sichere Byte
	  	sbrc 	Flag,bit			; springe 1x wenn empfangenes Bit=0 
	  	rjmp 	DCC_schleife		; sonst Byte nicht korrekt abgeschlossen
	  	clr 	Bitzaehler			; lsche Zhler

lesebyteB:							; hole zweites von bis zu sechs Bytes
	  	sbrs 	Flag,neuesbit		; wenn kein neues Bit dann
	  	rjmp 	PC-1				; Schleife
	  	cbr 	Flag,(1<<neuesbit)	; lsche flag fr neues Bit
	  	cpi 	Bitzaehler,8		; vergleiche mit Bytelnge		;
	  	breq 	byteBENDE			; und springe wenn Byte eingelesen
	  	sec							; setzte Carry
	  	sbrs 	Flag,bit			; wenn empfangenes Bit=1 1x springen
	  	clc							; lsche Carry
	  	rol 	byteB				; schiebe Carry von rechts in das Register
	  	inc 	Bitzaehler			; erhhe Zhler
	  	rjmp 	lesebyteB		  	; Schleife
byteBENDE:
		eor 	w,byteB				; bilde XOR	
	  	sbrc 	Flag,bit			; springe 1x wenn empfangenes Bit=0 
	  	rjmp 	DCC_schleife		; sonst Byte nicht korrekt abgeschlossen
	  	clr 	Bitzaehler			; lsche Zhler

lesebyteC:							; hole drittes von bis zu sechs Bytes
	  	sbrs 	Flag,neuesbit		; wenn kein neues Bit dann
	  	rjmp 	PC-1				; Schleife
	  	cbr 	Flag,(1<<neuesbit)	; lsche flag fr neues Bit
	  	cpi 	Bitzaehler,8		; vergleiche mit Bytelnge		;
	  	breq 	byteCENDE			; und springe wenn Byte eingelesen
	  	sec							; setzte Carry
	  	sbrs 	Flag,bit			; wenn empfangenes Bit=1 1x springen
	  	clc							; lsche Carry
	  	rol 	byteC				; schiebe Carry von rechts in das Register
	  	inc 	Bitzaehler			; erhhe Zhler
	  	rjmp 	lesebyteC		  	; Schleife	 
byteCENDE:
		eor 	w,byteC				; bilde XOR
	  	sbrc 	Flag,bit			; springe 1x wenn empfangenes Bit=0  
	  	rjmp 	Datenpruefen		; ansonsten Telegrammende
	  	clr 	Bitzaehler			; lsche Zhler

lesebyteD: 							; hole viertes von bis zu sechs Bytes
	  	sbrs 	Flag,neuesbit		; wenn kein neues Bit dann
	  	rjmp 	PC-1				; Schleife
	  	cbr 	Flag,(1<<neuesbit)	; lsche flag fr neues Bit
	  	cpi 	Bitzaehler,8		; vergleiche mit Bytelnge		;
	  	breq 	byteDENDE			; und springe wenn Byte eingelesen
	  	sec							; setzte Carry
	  	sbrs 	Flag,bit			; wenn empfangenes Bit=1 1x springen
	  	clc							; lsche Carry
	  	rol 	byteD				; schiebe Carry von rechts in das Register
	  	inc 	Bitzaehler			; erhhe Zhler
	  	rjmp 	lesebyteD		  	; Schleife	 
byteDENDE:
		eor 	w,byteD				; bilde XOR
	  	sbrc 	Flag,bit			; springe 1x wenn empfangenes Bit=0  
	  	rjmp 	Datenpruefen		; ansonsten Telegrammende
	  	clr 	Bitzaehler			; lsche Zhler

lesebyteE: 							; hole fnfte von bis zu sechs Bytes
	  	sbrs 	Flag,neuesbit		; wenn kein neues Bit dann
	  	rjmp 	PC-1				; Schleife
	  	cbr 	Flag,(1<<neuesbit)	; lsche flag fr neues Bit
	  	cpi 	Bitzaehler,8		; vergleiche mit Bytelnge		;
	  	breq 	byteEENDE			; und springe wenn Byte eingelesen
	  	sec							; setzte Carry
	  	sbrs 	Flag,bit			; wenn empfangenes Bit=1 1x springen
	  	clc							; lsche Carry
	  	rol 	byteE				; schiebe Carry von rechts in das Register
	  	inc 	Bitzaehler			; erhhe Zhler
	  	rjmp 	lesebyteE		  	; Schleife	 
byteEENDE:
		eor 	w,byteE				; bilde XOR
	  	sbrc 	Flag,bit			; springe 1x wenn empfangenes Bit=0  
	  	rjmp 	Datenpruefen		; ansonsten Telegrammende
	  	clr 	Bitzaehler			; lsche Zhler

lesebyteF: 							; hole sechste von bis zu sechs Bytes
	  	sbrs 	Flag,neuesbit		; wenn kein neues Bit dann
	  	rjmp 	PC-1				; Schleife
	  	cbr 	Flag,(1<<neuesbit)	; lsche flag fr neues Bit
	  	cpi 	Bitzaehler,8		; vergleiche mit Bytelnge		;
	  	breq 	byteFENDE			; und springe wenn Byte eingelesen
	  	sec							; setzte Carry
	  	sbrs 	Flag,bit			; wenn empfangenes Bit=1 1x springen
	  	clc							; lsche Carry
	  	rol 	byteF				; schiebe Carry von rechts in das Register
	  	inc 	Bitzaehler			; erhhe Zhler
	  	rjmp 	lesebyteF		  	; Schleife
	 
byteFENDE:
		eor 	w,byteF				; bilde XOR
	  	sbrs 	Flag,bit			; springe 1x wenn empfangenes Bit=1 
	  	rjmp 	DCC_schleife		; sonst Byte nicht korrekt abgeschlossen

Datenpruefen:						; Datenprfung und bergabe
		tst 	w					; prfe w auf 0			 	 
	  	brne 	pruefFehl			; wenn nicht 0 dann Fehler
	  
		ret							; sonst mit neuem Daten in byteA-F zurck
pruefFehl:							; wenn Prfsummenfehler
	  	rjmp 	DCC_schleife		; Endlosschleife
