;************************************
;*	Geschwindigkeit setzen			*
;************************************
; hier werden neue Fahrbefehle gesetzt zuerst Basis Format
; die neuen Daten kommen in w hier an

V_Basis:							; V Berechnung 14 und 28 Fahrstufen
									; zuerst Richtung schreiben
	  	mov 	w2,w				; Daten sichern
	  	tst 	V_IST				; ist V ungleich 0 ?
	  	brne 	V_set				; wenn ja gehe zu Fahrstufen setzen
									; ansonsten auf Richtungswechsel testen/setzen
	  	sbrc 	DCCReg,richtung_inv	; wenn Fahrrichtung nicht reversiert 1x springen
        com 	w2					; ansonsten wird neue Richtung gedreht	
        bst 	w2,5				; hole Richtungsbit
	  	bld 	DCCReg,richtung		; nach DCC Register
		sbrs	DCCReg,richtung		; und setze RichtungsPort
		cbi		Portb,MotR		
		sbrc	DCCReg,richtung
		sbi		Portb,MotR
V_set:								; Fahrstufen setzen
		sbrc	DCCReg,fahrstufen	; 0=14 Fahrstufen 1x springen
		rjmp	V_28set				; wenn 28 gehe zu
		bst		w,4					; Lichtbit holen
		bld		DCCReg,FL			; und in FL ablegen
		cbr		w,0b11110000		; bits fr kennung, richtung und licht lschen

V_28set:							; ab hier fr 14 und 28 Fahrstufen gleich
		bst		w,4					; bit0 fr 28 Fahrstufen sichern
		cbr		w,0b11110000		; bits fr kennung und richtung lschen
		cpi		w,2					; auf stop (0) und notstop (1) testen
		brlo	stop				; wenn kleiner (2) gehe zu
		rol		w					; 1x nachlinks verschieben
		bld		w,0					; und bit0 wieder einfgen
		sbrc	DCCReg,nutzeKennl	; wenn nicht nach Kennline in CV67-94 1xspringen
		rjmp	Kennlinie_set		; sonst gehe zu..
		mov		w2,w				; V_max begrenzung auf 25% 50% 75% 100% 125% 150%
									; der sinnvollen PWM Impulsbreite setzen
		lds		w3,V_max			; V_max holen
		cpi		w3,25				; und zur Berechnung verzweigen
		breq	V25set
		cpi		w3,50
		breq	V50set
		cpi		w3,75
		breq	V75set				
		cpi		w3,100
		breq	V100set
		cpi		w3,125
		breq	V125set
V150set:add		w,w2
V125set:add		w,w2
V100set:add		w,w2				; bei allen anderen Werten immer 100%
V75set:	add		w,w2	
V50set:	add		w,w2
V25set:
V_start_set:						; Startspannung nach VC2 setzen
		lds		w2,V_start			; mindest Impulsbreite (V_start) holen
		add		w,w2				; und zur aktuellen Geschw. addieren
		mov		V_soll,w
		rjmp	Hauptschleife		; und fertig

Kennlinie_set:						; Kennlinienwert je nach Fahrstufe holen
									; auch bei 14 Fs mglich (es wird jeder 2. Wert benutzt)
		ldi		yl,low(kennline)	; setze Pointer auf Kennline
		ldi		yh,high(kennline)
		subi	w,4					; kleinste der 28 FS ist 4, darum erst 4 subtrahieren
		add		yl,w				; hier nur kleiner Ram, 8bit Addition ist ausreichend
		ld		w,y					; in w Kennlinienwert laden
		mov		V_soll,w
		rjmp	Hauptschleife

stop:
	  	clr 	V_SOLL				; Notstop machen
	  	clr 	V_IST				;
		clr		FSzaehler			; Zaehler fr spteren neustart auf kleinsten wert setzen
		inc		FSzaehler
		in		w,TCCR1A
    	cbr		w,(1<<COM1A1)		; PWM Ausgang trennen
		out		TCCR1A,w
	  	rjmp	Hauptschleife	

erw_Operation:
		
		rjmp	Hauptschleife
