;****************************************************************************************
;*						RS232 m8														*
;****************************************************************************************

;********************************
;*		rs232 Byte senden		*
;********************************
serial_out:
    		sbis    UCSRA,UDRE          ; Warten bis UDR fr das nchste
                                        ; Byte bereit ist
    		rjmp    serial_out
    		out     UDR, w
    		ret                         ; zurck zum Hauptprogramm

;********************************
;*		UART init				*
;********************************
;UART Initalisierung

init_uart_m8:
    		ldi     w,HIGH(UBRR_Wert)	; Baudrate einstellen
    		out     UBRRH,w
    		ldi     w,LOW(UBRR_Wert)
    		out     UBRRL,w
 
 			ldi     w,0b10000110		; USART Control and Status Register C UCSRC
    		out     UCSRC,w				; Bit7 URSEL: Register Select UCSRC oder UBRRH 
										; The URSEL must be one when writing the UCSRC.
										; Bit6 UMSEL: USART Mode Select 0=Asynchronous Operation
										; Bit5/4 UPM1/0: Parity Mode
										;			0 0 Disabled
										;			0 1 Reserved
										;			1 0 Enabled, Even Parity
										;			1 1 Enabled, Odd Parity
										; Bit3 USBS: Stop Bit Select 0=1bit 1=2bit
										; Bit2/1 UCSZ1/0: Character Size 1/1 = 8bit
										; Bit0 UCPOL: Clock Polarity asyncMode immer 0
 										
    		ldi     w,0b00001000        ; USART Control and Status Register B UCSRB
			out		UCSRB,w				; Bit7 RXCIE: RX Complete Interrupt Enable
										; Bit6 TXCIE: TX Complete Interrupt Enable
										; Bit5 UDRIE: USART Data Register Empty Interrupt Enable
										; Bit4 RXEN: Receiver Enable
										; Bit3 TXEN: Transmitter Enable
										; Bit2 UCSZ2: Character Size
										; Bit1 RXB8: Receive Data Bit 8
										; Bit0 TXB8: Transmit Data Bit 8

			ldi		w,0b0000000			; USART Control and StatusRegister A UCSRA
			out		UCSRA,w				; Bit7 RXC: USART Receive Complete
										; Bit6 TXC: USART Transmit Complete
										; Bit5 UDRE: USART Data Register Empty
										; Bit4 FE: Frame Error
										; Bit3 DOR: Data OverRun
										; Bit2 PE: Parity Error
										; Bit1 U2X: Double the USART transmission speed 0=normal=16fach
										; Bit0 MPCM: Multi-processor Communication Mode
			ret
